
#http://kembellab.ca/r-workshop/biodivR/SK_Biodiversity_R.html
#http://jonlefcheck.net/2012/10/24/nmds-tutorial-in-r/

#https://cran.r-project.org/web/packages/vegan/vignettes/intro-vegan.pdf
library(picante)
library(vegan)
library(ggplot2)
library(ggrepel)
library(dplyr)

####https://www.rpubs.com/RGrieger/545184



data <- read.csv("C:/Users/liz/Dropbox/Greenhouse germination study 2018/pie charts of abundances with top 10 foxtail etcNAMES Corrected12.8.csv",header=T)
data.env<-read.csv("C:/Users/liz/Dropbox/Greenhouse germination study 2018/groups.csv",header=T)


#All species
comm <- as.matrix(data[,2:52])

#Just Seeded
#comm <- as.matrix(data[,2:34])
class(comm)
dim(comm)
rownames(comm)
head(colnames(comm))
comm[1:5,1:5]
apply(comm, 1, sum)
comm<-decostand(comm, method="total")
apply(comm, 1, sum)
comm[1:5,1:5]
set.seed(123456)
commnmds=metaMDS(comm,k=2,trymax=100)
commnmds
plot(commnmds)

dune.spp.fit <- envfit(commnmds, data, permutations = 999)

site.scrs <- as.data.frame(scores(commnmds, display = "sites")) #save NMDS results into dataframe
Management<-data.env$Management
site.scrs <- cbind(site.scrs, Management) #add grouping variable "Management" to dataframe
#site.scrs <- cbind(site.scrs, Landuse = dune.env$Use) #add grouping variable of cluster grouping to dataframe
#site.scrs <- cbind(site.scrs, Site = rownames(site.scrs)) #add site names as variable if you want to display on plot

head(site.scrs)
site.scrs


spp.scrs <- as.data.frame(scores(dune.spp.fit, display = "vectors")) #save species intrinsic values into dataframe
spp.scrs <- cbind(spp.scrs, Species = rownames(spp.scrs)) #add species names to dataframe
spp.scrs <- cbind(spp.scrs, pval = dune.spp.fit$vectors$pvals) #add pvalues to dataframe so you can select species which are significant
#spp.scrs<- cbind(spp.scrs, abrev = abbreviate(spp.scrs$Species, minlength = 6)) #abbreviate species names
sig.spp.scrs <- subset(spp.scrs, pval<=0.05) #subset data to show species significant at 0.05

head(spp.scrs)


###
spp.scrs <- as.data.frame(scores(dune.spp.fit, display = "vectors")) #save species intrinsic values into dataframe
spp.scrs <- cbind(spp.scrs, Species = rownames(spp.scrs)) #add species names to dataframe
spp.scrs <- cbind(spp.scrs, pval = dune.spp.fit$vectors$pvals) #add pvalues to dataframe so you can select species which are significant
#spp.scrs<- cbind(spp.scrs, abrev = abbreviate(spp.scrs$Species, minlength = 6)) #abbreviate species names
sig.spp.scrs <- subset(spp.scrs, pval<=0.0999) #subset data to show species significant at 0.05
sig.spp.scrs
head(spp.scrs)
spp.scrs

###NOW TO PUT INTO GG PLOT FOR BEAUTIFICATION
nmds.plot.dune <- ggplot(site.scrs, aes(x=NMDS1, y=NMDS2))+ #sets up the plot
  geom_point(aes(NMDS1, NMDS2, shape = factor(data$Management)), size = 2)+ #adds site points to plot, shape determined by Landuse, colour determined by Management
  coord_fixed()+
  theme_classic()+ 
  theme(panel.background = element_rect(fill = NA, colour = "black", size = 1, linetype = "solid"))+
  labs(shape = "Landuse")+ # add legend labels for Management and Landuse
  theme(legend.position = "right", legend.text = element_text(size = 12), legend.title = element_text(size = 12), axis.text = element_text(size = 10)) # add legend at right of plot

nmds.plot.dune + labs(title = "Basic ordination plot") #displays plot



##
nmds.plot.dune+
  geom_segment(data = sig.spp.scrs, aes(x = 0, xend=NMDS1, y=0, yend=NMDS2), arrow = arrow(length = unit(0.25, "cm")), colour = "grey10", lwd=0.3) + #add vector arrows of significant species
  ggrepel::geom_text_repel(data = sig.spp.scrs, aes(x=NMDS1, y=NMDS2, label = Species), cex = 5, direction = "both", segment.size = 0.25, max.overlaps = 10)+ #add labels for species, use ggrepel::geom_text_repel so that labels do not overlap
  labs(title = "Ordination with species vectors")
###if needed,    max.overlaps = 10
###broken####    ordiellipse(commnmds, data.env$Management, display = "sites", kind = "sd", label = T)


###plot works!!


####other not woring elipsies tsuff
#ordiplot(commnmds, type = "n", main = "ellipses")
#orditorp(commnmds, display = "sites", labels = F, pch = c(16, 8, 17, 18) [as.numeric(data.env$Management)], col = c("green", "blue", "orange", "black") [as.numeric(dune.env$Management)], cex = 1)
#ordiellipse(dune.mds, groups = dune.env$Management, draw = "polygon", lty = 1, col = "grey90")


###### not workign elipses stuff from Grieger
# function for ellipsess 

veganCovEllipse <- function (cov, center = c(0, 0), scale = 1, npoints = 100) 
{
  theta <- (0:npoints) * 2 * pi/npoints
  Circle <- cbind(cos(theta), sin(theta))
  t(center + scale * t(Circle %*% chol(cov)))
}

##patch??
site.scrs$Management <- as.factor(site.scrs$Management)
#site.scrs$group <- as.factor(site.scrs$Management)
site.scrs
site.scrs$Management

#data for ellipse, in this case using the management factor
df_ell.dune.management <- data.frame() #sets up a data frame before running the function.
for(g in levels(site.scrs$Management)){
  df_ell.dune.management <- rbind(df_ell.dune.management, cbind(as.data.frame(with(site.scrs [site.scrs$Management==g,],
                                                                                   veganCovEllipse(cov.wt(cbind(NMDS1,NMDS2),wt=rep(1/length(NMDS1),length(NMDS1)))$cov,center=c(mean(NMDS1),mean(NMDS2))))) ,Management=g))
}

df_ell.dune.management



# data for labelling the ellipse
NMDS.mean.dune=aggregate(site.scrs[ ,c("NMDS1", "NMDS2")], 
                         list(group = site.scrs$Management), mean)

NMDS.mean.dune


# data for labelling the ellipse
#NMDS.mean=aggregate(site.scrs[,c("NMDS1", "NMDS2")], 
#list(group = site.scrs$Management), mean)
nmds.plot.dune+ 
  geom_path(data = df_ell.dune.management, aes(x = NMDS1, y = NMDS2,  group = site.scrs$Management), colour ="yellow") #this is the ellipse, seperate ones by Site. 



####
##
#Trying failed, to add color
ggplot(data = df_ell.dune.management, aes(NMDS1, NMDS2)) + geom_point(aes(color = Management)) +
  geom_path(data=df_ell.dune.management, aes(x=NMDS1, y=NMDS2,colour=Management), size=1, linetype=2)+
  
  ##wont add## 
  
  geom_segment(data = sig.spp.scrs, aes(x = 0, xend=NMDS1, y=0, yend=NMDS2), arrow = arrow(length = unit(0.25, "cm")), colour = "grey10", lwd=0.3) + #add vector arrows of significant species
  ggrepel::geom_text_repel(data = sig.spp.scrs, aes(x=NMDS1, y=NMDS2, label = Species), cex = 8, direction = "both", segment.size = 0.25, max.overlaps = 100)+ #add labels for species, use ggrepel::geom_text_repel so that labels do not overlap
  labs(title = "")+guides(color=guide_legend("Inoculation Treatment"))+
  
  
  theme(panel.background = element_rect(fill = 'white', colour = 'black'))+
  theme(panel.grid.major = element_blank(), panel.grid.minor = element_blank())+
  theme(axis.text = element_text(size = 12)) + # change axis font size
  theme(axis.title.y = element_text(size = rel(1.5), angle=90))+ # change axis label font size
  theme(axis.title.x = element_text(size = rel(1.5)))+
  theme(legend.text=element_text(size=12))+ # change legend font size
  theme(legend.title=element_text(size=12))




